/*
 * storcompacter.h: this file is part of the StorCompacter project.
 *
 * StorCompacter, a Storage Compaction optimizer.
 *
 * Copyright (C) 2010 Louis-Noel Pouchet
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * The complete GNU Lesser General Public Licence Notice can be found
 * as the `COPYING.LESSER' file in the root directory.
 *
 * Author:
 * Louis-Noel Pouchet <pouchet@cse.ohio-state.edu>
 */
#ifndef STORCOMPACTER_STORCOMPACTER_H
# define STORCOMPACTER_STORCOMPACTER_H

# include <storcompacter/common.h>

# ifndef LINEAR_VALUE_IS_LONGLONG
#  define LINEAR_VALUE_IS_LONGLONG
# endif
# ifndef SCOPLIB_INT_T_IS_LONGLONG
#  define SCOPLIB_INT_T_IS_LONGLONG
# endif
# define CLOOG_SUPPORTS_SCOPLIB
# include <scoplib/scop.h>
# include <cloog/cloog.h>
# include <cloog/clast.h>


BEGIN_C_DECLS


extern
int
storcompacter (scoplib_scop_p scop, struct clast_stmt* root);


END_C_DECLS


#endif // STORCOMPACTER_STORCOMPACTER_H
